﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xamarin.Forms;

namespace AppBayFinal2019
{
    public class PageColChanger : ContentPage
    {
        Label lab;
        BoxView box;
        Button btnRGB, btnHSL;
        Slider slR, slG, slB, slHue, slSat, slLum;
        bool rgb;
        public PageColChanger()
        {

            Label LabTitle = new Label
            {
                Text = "Demo Page for Color Changing",
                FontSize = 20.0,
            };
            lab = new Label
            {
                Text = "Top R--G--B, Bottom: Hue, Saturation, Luminosity",
                VerticalOptions = LayoutOptions.Start
            };
            btnRGB = new Button
            {
                Text = "Change RGB- Values",
            };
            btnRGB.Clicked += BtnRGB_Clicked;
            btnHSL = new Button
            {
                Text = "Change HSL - Values",
            };
            btnHSL.Clicked += BtnHSL_Clicked;
            slR = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start,
            };
            slR.ValueChanged += SlR_ValueChanged;
            slG = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start
            };
            slG.ValueChanged += SlG_ValueChanged;

            slB = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start
            };
            slB.ValueChanged += SlB_ValueChanged;


            slHue = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start,
            };
            slHue.ValueChanged += SlHue_ValueChanged;
            slSat = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start,
            };
            slSat.ValueChanged += SlSat_ValueChanged;

            slLum = new Slider
            {
                Maximum = 255,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start,
            };

            slLum.ValueChanged += SlLum_ValueChanged;

            box = new BoxView
            {
                VerticalOptions = LayoutOptions.FillAndExpand,
                //Aspect = Aspect.AspectFit,
                HorizontalOptions = LayoutOptions.Fill,
                BackgroundColor = Color.Gray,
            };
            Content = new StackLayout
            {
                Children =
                {
                    LabTitle,lab,btnRGB,slR,slG,slB,
                    box,btnHSL,slHue,slSat,slLum
                }
            };
            this.Padding = new Thickness(20, 20, 20, 20);
            rgb = true;
        }

        private void BtnHSL_Clicked(object sender, EventArgs e)
        {
            rgb = false;
        }

        private void BtnRGB_Clicked(object sender, EventArgs e)
        {
            rgb = true;
        }

        private void SlLum_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            if (!rgb)
            {
                slR.Value = box.BackgroundColor.R * 255;
                slG.Value = box.BackgroundColor.G * 255;
                slB.Value = box.BackgroundColor.B * 255;
                box.BackgroundColor = Color.FromHsla(slHue.Value / 255.0, slSat.Value / 255.0, slLum.Value / 255);
            }
        }

        private void SlSat_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            if (!rgb)
            {
                slR.Value = box.BackgroundColor.R * 255;
                slG.Value = box.BackgroundColor.G * 255;
                slB.Value = box.BackgroundColor.B * 255;
                box.BackgroundColor = Color.FromHsla(slHue.Value / 255.0, slSat.Value / 255.0, slLum.Value / 255);
            }

        }

        private void SlHue_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            if (!rgb)
            {
                slR.Value = box.BackgroundColor.R * 255;
                slG.Value = box.BackgroundColor.G * 255;
                slB.Value = box.BackgroundColor.B * 255;
                box.BackgroundColor = Color.FromHsla(slHue.Value / 255.0, slSat.Value / 255.0, slLum.Value / 255);
            }
        }

        private void SlB_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            
            if (rgb)
            {
                slHue.Value = box.BackgroundColor.Hue * 255;
                slSat.Value = box.BackgroundColor.Saturation * 255;
                slLum.Value = box.BackgroundColor.Luminosity * 255;
                box.BackgroundColor = Color.FromRgb(slR.Value / 255.0, slG.Value / 255.0, slB.Value / 255.0);
            }
        }

        private void SlG_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            if (rgb)
            {
                slHue.Value = box.BackgroundColor.Hue * 255;
                slSat.Value = box.BackgroundColor.Saturation * 255;
                slLum.Value = box.BackgroundColor.Luminosity * 255;
                box.BackgroundColor = Color.FromRgb(slR.Value / 255.0, slG.Value / 255.0, slB.Value / 255.0);
            }
        }

        private void SlR_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            if (rgb)
            {
                slHue.Value = box.BackgroundColor.Hue * 255;
                slSat.Value = box.BackgroundColor.Saturation * 255;
                slLum.Value = box.BackgroundColor.Luminosity * 255;
                box.BackgroundColor = Color.FromRgb(slR.Value / 255.0, slG.Value / 255.0, slB.Value / 255.0);
            }
        }
    }
}