﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xamarin.Forms;

namespace AppBayFinal2019
{

    public class PageGesture : ContentPage
    {
        Label lab;
        Image image;
         public PageGesture()
        {
            this.Title = "Tab3 ohne Scollview";
            lab = new Label
            {
                Text = "Demo für GestureRecognizer",
                VerticalOptions = LayoutOptions.Start
,
                HorizontalOptions = LayoutOptions.Start
            };
            Button butDefault = new Button
            {
                Text = "Default",
                HorizontalOptions = LayoutOptions.End
            };
            butDefault.Clicked += ButDefault_Clicked;

            image = new Image
            {
                Source = ImageSource.FromResource("AppBayFinal2019.regcSharp.jpg"),

                //Source = ImageSource.FromUri(new Uri("http://www.joergbayerlein.de/wp-content/uploads/2015/06/regcSharp.jpg")),
                VerticalOptions = LayoutOptions.Center,
                Aspect = Aspect.AspectFit,
                HorizontalOptions = LayoutOptions.Center,
                BackgroundColor = Color.Gray,
            };
            image.SizeChanged += Image_SizeChanged;

            TapGestureRecognizer tap = new TapGestureRecognizer();
            tap.Tapped += Tap_Tapped;
            image.GestureRecognizers.Add(tap);

            PanGestureRecognizer pan = new PanGestureRecognizer();
            pan.PanUpdated += Pan_PanUpdated;
            image.GestureRecognizers.Add(pan);

            PinchGestureRecognizer pinch = new PinchGestureRecognizer();
            pinch.PinchUpdated += Pinch_PinchUpdated;
            image.GestureRecognizers.Add(pinch);

            Content = new StackLayout
            {
                Children =
                {
                    new StackLayout
                    {
                        Orientation=StackOrientation.Horizontal,
                        Children =
                        {
                            lab,butDefault
                        }

                    },
                   
                    image
                }
            };
        }

        private void ButDefault_Clicked(object sender, EventArgs e)
        {
            image.AnchorX = 0.5;
            image.AnchorY = 0.5;
            image.TranslationX = 0;
            image.TranslationY = 0;
            image.Scale = 1;
            image.Rotation = 0;
            image.RotationX = 0;
            image.RotationY = 0;
        }

        double startScale = 1;
        double currentScale = 1;
        
        private void Pinch_PinchUpdated(object sender, PinchGestureUpdatedEventArgs e)
        {
            if (e.Status == GestureStatus.Started)
            {
                startScale = image.Scale;
                image.AnchorX = e.ScaleOrigin.X;
                image.AnchorY = e.ScaleOrigin.Y;
            }
            if (e.Status == GestureStatus.Running)
            {
                // Calculate the scale factor to be applied.
                currentScale += (e.Scale - 1) * startScale;
                currentScale = Math.Max(0.5, currentScale);
                currentScale = Math.Min(4, currentScale);
                // Apply scale factor.
                image.Scale = currentScale;
            }
            if (e.Status == GestureStatus.Completed)
            {
                // nach Ende Pinch
                
            }
            lab.Text = "Pinched mit " + currentScale.ToString("f3")+" originx "+ e.ScaleOrigin.X.ToString("f2")+ " originy " + e.ScaleOrigin.Y.ToString("f2");

        }

        double xoff = 0, yoff = 0;
 
        private void Pan_PanUpdated(object sender, PanUpdatedEventArgs e)
        {
            lab.Text = "Image is panned "+ image.TranslationX.ToString("f2")+" "+ image.TranslationY.ToString("f2");
            double x=e.TotalX, y=e.TotalY;
            if (e.StatusType==GestureStatus.Running)
            {
                double xnew=e.TotalX+xoff,ynew=e.TotalY+yoff;
                if (xnew > this.Width) xnew = this.Width;
                if (xnew < -image.Width) xnew = -image.Width;
                image.TranslationX = xnew;
                if (ynew > this.Height) ynew = this.Height;
                if (ynew < - image.Height) ynew = - image.Height;
                image.TranslationY = ynew;

            }
            if (e.StatusType==GestureStatus.Completed)
            {
                xoff = image.TranslationX;
                yoff = image.TranslationY;
            }
            if (e.StatusType==GestureStatus.Started)
            {
                xoff = image.TranslationX;
                yoff = image.TranslationY;
            }
        }

        private void Tap_Tapped(object sender, EventArgs e)
        {
            lab.Text = "Image is tapped on ";
            xoff = image.TranslationX;
            yoff = image.TranslationY;
        }


        private void Image_SizeChanged(object sender, EventArgs e)
        {
            //lab.Text = "Width= " + image.Width + "Height= " + image.Height;
        }

 
    }
}