﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xamarin.Forms;

namespace AppBayFinal2019
{
    public class Page1 : MasterDetailPage
    {
        public Color ColorBack;
        public Color ColorText;
        public string PicResource;
        public string BackIcon;
        public string BackIconiOS;
        public PageBay pt6;
        PageTab6 pt6a;
        PageTab2 pt2;
        PageTab3 pt3;
        PageTab4 pt4;
        PageTab5 pt5;
        PageTrans ptrans;
        ColorChanger pcc;
        PageLO plo;
        PageGestureSimple pgs;
        PageStartInfo pstinfo;
        Label header;

        class Pages
        {
            public Pages(string name)
            {
                this.Name = name;
            }

            public string Name { private set; get; }

        };


        public Page1()
        {
            // Central definition of Menu color and text color of headlines
            ColorBack = Color.DodgerBlue;
            ColorText = Color.White;
            // central definition of location and nam of used picture
            // namespace.name.extension (case sensitive!!!)
            PicResource = "AppBayFinal2019.regcSharp.jpg";
            BackIcon = "AppBayFinal2019.ic_arrow_back_white_48dp.png";
            BackIconiOS = "AppBayFinal2019.ic_arrow_white_ios_48dp.png";

            pt6 = new PageBay(this);        // PageBayReuter.cs
            pt6a = new PageTab6(this);  //PageFetchData.cs
            pt2 = new PageTab2(this); //PageImageLayoutAspectScrollVert.cs
            pt3 = new PageTab3(this); //PageImageLayoutAspectohneScroll.cs
            pt4 = new PageTab4(this); //PageAlertBox.cs
            pt5 = new PageTab5(this); //PageImageLayoutAspectScrollboth.cs
            ptrans = new PageTrans(this); //PageTransRotScaleAnchor.cs
            pcc = new ColorChanger(this); //PageIColorChanger.cs
            plo = new PageLO(this); //PageLayoutOptions.cs
            pgs = new PageGestureSimple(this);
            pstinfo = new PageStartInfo(this);

            // central definition of Menu/ Header colors of all pages

            header = new Label
            {
                Text = "Xamarin Demo Bayerlein",
                FontSize = 20,
                FontAttributes = FontAttributes.Bold,
                TextColor = ColorText
            };
           

            // Define some data.
            List<Pages> pagelist = new List<Pages>
            {
                new Pages("Start Info"),
                new Pages("Reuter"),
                new Pages("Fetch Data"),
                new Pages("Image vert scroll"),
                new Pages("Image without scroll"),
                new Pages("Image both scroll"),
                new Pages("Alert"),
                new Pages("Trans etc"),
                new Pages("Color Changer"),
                new Pages("Layout Options"),
                new Pages("Simple Gestures"),
                
            };




            // Create ListView for the master page.
            ListView listView = new ListView
            {
                // Source of data items.
                ItemsSource = pagelist,

                // Define template for displaying each item.
                // (Argument of DataTemplate constructor is called for 
                //      each item; it must return a Cell derivative.)
                ItemTemplate = new DataTemplate(() =>
                {
                    // Create views with bindings for displaying each property.
                    Label nameLabel = new Label
                    {
                        BackgroundColor=ColorBack,
                        TextColor=ColorText,
                        VerticalOptions=LayoutOptions.CenterAndExpand,
                        HorizontalOptions=LayoutOptions.FillAndExpand

                    };
                    nameLabel.SetBinding(Label.TextProperty, "Name");

                    // Return an assembled ViewCell.
                    return new ViewCell
                    {
                        View = new StackLayout
                        {
                            //Padding = new Thickness(0, 5),
                            //Orientation = StackOrientation.Horizontal,
                            BackgroundColor=ColorBack,
                            Children =
                            {
                                nameLabel,
                            }
                        }
                    };
                })
            };
            listView.ItemSelected += ListView_ItemSelected;
            listView.ItemTapped+= ListView_ItemTapped;
            this.Master = new ContentPage
            {
                Title = "Page List", // Title required!
                WidthRequest = 1,
                BackgroundColor = ColorBack,
                Content = new StackLayout
                {
                    Children = {
                        header,
                        listView
                    },
                    HorizontalOptions = LayoutOptions.Start,
                }
            };
            this.Detail = pstinfo;
            this.IsPresented = true;
            this.Detail.Padding = new Thickness(10, 10, 10, 0);
            if (Device.RuntimePlatform == Device.iOS)
            {
                this.Detail.Padding = new Thickness(10, 30, 10, 0);
                this.Master.Padding = new Thickness(10, 30, 0, 0);
                //ColorText = Color.Blue;
            }
            else
            {
                this.Detail.Padding = new Thickness(10, 10, 10, 0);
                this.Master.Padding = new Thickness(10, 10, 0, 0);
            }
        }

        private void ListView_ItemTapped(object sender, ItemTappedEventArgs e)
        {

            this.IsPresented = false;
            this.Detail.Padding = new Thickness(10, 10, 10, 0);
            if (Device.RuntimePlatform == Device.iOS)
                this.Detail.Padding = new Thickness(10, 30, 10, 0);
        }

        private void ListView_ItemSelected(object sender, SelectedItemChangedEventArgs e)
        {
            Pages p = (Pages)e.SelectedItem;
            //header.Text = p.Name;
            switch (p.Name)
            {
                case "Reuter": this.Detail = pt6; break;
                case "Fetch Data": this.Detail = pt6a; break;
                case "Image vert scroll": this.Detail = pt2; break;
                case "Image without scroll": this.Detail = pt3; break;
                case "Alert": this.Detail = pt4; break;
                case "Image both scroll": this.Detail = pt5; break;
                case "Trans etc": this.Detail = ptrans; break;
                case "Color Changer": this.Detail = pcc; break;//"Color Changer"
                case "Layout Options": this.Detail = plo; break;//
                case "Simple Gestures": this.Detail = pgs; break;//Simple Gestures
                case "Start Info": this.Detail = pstinfo;break;


            }
            this.IsPresented = false;
            this.Detail.Padding = new Thickness(10, 10, 10, 0);
            if (Device.RuntimePlatform == Device.iOS)
                this.Detail.Padding = new Thickness(10, 30, 10, 0);
        }

    }
}
    
