﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xamarin.Forms;

namespace AppBayFinal2019
{
    public class PageTab4 : ContentPage
    {
        Page1 MeinMain;
        Image butback;
        public PageTab4(Page1 m)
        {
            MeinMain = m;
            Button but = new Button
            {
                Text = "Klick macht ne AlertBox",
                VerticalOptions = LayoutOptions.Start,
                WidthRequest = Device.RuntimePlatform == Device.UWP ? 250 : 200
            };
            but.Clicked += But_Clicked;
            switch (Device.RuntimePlatform)
            {
                case Device.UWP:  but.Text += " UWP";break;
                case Device.iOS: but.Text += " iOS";break;
                case Device.Android: but.Text += " Android";break;
            };

            butback = new Image
            {
                WidthRequest = 30,
                HorizontalOptions = LayoutOptions.Start,
                BackgroundColor = MeinMain.ColorBack,
                Source = ImageSource.FromResource(MeinMain.BackIcon)
            };

            TapGestureRecognizer tap = new TapGestureRecognizer();
            tap.Tapped += Tap_Tapped;
            butback.GestureRecognizers.Add(tap);

            Label LabTitle = new Label
            {
                Text = "Alert Box Demo",
                FontSize = 20.0,
                HorizontalOptions = LayoutOptions.End,
                BackgroundColor = MeinMain.ColorBack,
                TextColor = MeinMain.ColorText
            };

            StackLayout top = new StackLayout
            {
                Orientation = StackOrientation.Horizontal,
                Children =
                {
                   butback,LabTitle
                },
                HorizontalOptions = LayoutOptions.FillAndExpand,
                BackgroundColor = MeinMain.ColorBack,
                Padding=new Thickness(10,0,0,0)
            };



            Content = new StackLayout
            {
                Children =
                {
                    top,
                    but
                }
            };
            if (Device.RuntimePlatform == Device.UWP)
                this.butback.IsVisible = false;
            else if (Device.RuntimePlatform == Device.iOS)
                this.butback.Source = ImageSource.FromResource(MeinMain.BackIconiOS);

        }

        private void Tap_Tapped(object sender, EventArgs e)
        {
            MeinMain.IsPresented = true;
        }

        private async void  But_Clicked(object sender, EventArgs e)
        {
            bool alert = await DisplayAlert("Alert", "Are you sure to change the background color of page?", "Yes", "No");
            if (alert)
            {
                this.BackgroundColor = Color.LightBlue;
            }
            else
                this.BackgroundColor = Color.Red;
        }
    }
}