﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xamarin.Forms;

namespace AppBayFinal2019
{

    public class PageGestureSimple : ContentPage
    {
        Label lab;
        Image image;
        Label info;
        Page1 MeinMain;
        Image butback;
        public PageGestureSimple(Page1 m)
        {
            MeinMain = m;
            butback = new Image
            {
                WidthRequest = 30,
                HorizontalOptions = LayoutOptions.Start,
                BackgroundColor = MeinMain.ColorBack,
                Source = ImageSource.FromResource(MeinMain.BackIcon)
            };

            TapGestureRecognizer tap1 = new TapGestureRecognizer();
            tap1.Tapped += Tap1_Tapped;
            butback.GestureRecognizers.Add(tap1);

            Label LabTitle = new Label
            {
                Text = "Demo for the three Gesture Methods Tap, Pan and Pinch",
                FontSize = 20.0,
                HorizontalOptions = LayoutOptions.End,
                BackgroundColor = MeinMain.ColorBack,
                TextColor = MeinMain.ColorText
            };
            StackLayout top = new StackLayout
            {
                Orientation = StackOrientation.Horizontal,
                Children =
                {
                   butback,LabTitle
                },
                HorizontalOptions = LayoutOptions.FillAndExpand,
                BackgroundColor = MeinMain.ColorBack,
                //Padding = new Thickness(10, 0, 0, 0)
            };

            info = new Label
            {
                Text = "Gest info",
                VerticalOptions = LayoutOptions.Start,
                HorizontalOptions = LayoutOptions.Start
            };
            lab = new Label
            {
                Text = "Gest info2",
                VerticalOptions = LayoutOptions.Start,
                HorizontalOptions = LayoutOptions.Start
            };
            Button butDefault = new Button
            {
                Text = "Default",
                HorizontalOptions = LayoutOptions.End
            };
            butDefault.Clicked += ButDefault_Clicked;

            image = new Image
            {
                Source = ImageSource.FromResource(MeinMain.PicResource),
                VerticalOptions = LayoutOptions.FillAndExpand,
                Aspect = Aspect.AspectFit,
                HorizontalOptions = LayoutOptions.Fill,
                BackgroundColor = Color.Gray,
            };
            image.SizeChanged += Image_SizeChanged;

            TapGestureRecognizer tap = new TapGestureRecognizer();
            tap.Tapped += Tap_Tapped;
            image.GestureRecognizers.Add(tap);

            PanGestureRecognizer pan = new PanGestureRecognizer();
            pan.PanUpdated += Pan_PanUpdated;
            image.GestureRecognizers.Add(pan);

            PinchGestureRecognizer pinch = new PinchGestureRecognizer();
            pinch.PinchUpdated += Pinch_PinchUpdated;
            image.GestureRecognizers.Add(pinch);

            Content = new StackLayout
            {
                Children =
                {
                    top,butDefault,lab,
                    info,
                    image
                }
            };
            if (Device.RuntimePlatform == Device.UWP)
                this.butback.IsVisible = false;
            else if (Device.RuntimePlatform == Device.iOS)
                this.butback.Source = ImageSource.FromResource(MeinMain.BackIconiOS);
        }

        private void Tap1_Tapped(object sender, EventArgs e)
        {
            MeinMain.IsPresented = true;
        }

        private void ButDefault_Clicked(object sender, EventArgs e)
        {
            image.AnchorX = 0.5;
            image.AnchorY = 0.5;
            image.TranslationX = 0;
            image.TranslationY = 0;
            image.Scale = 1;
            image.Rotation = 0;
            image.RotationX = 0;
            image.RotationY = 0;
            startScale = 1;
            currentScale = 1;
        }

        double startScale = 1;
        double currentScale = 1;
        
        private void Pinch_PinchUpdated(object sender, PinchGestureUpdatedEventArgs e)
        {
            if (e.Status == GestureStatus.Started)
            {
                startScale = image.Scale;
                //image.AnchorX = e.ScaleOrigin.X;
                //image.AnchorY = e.ScaleOrigin.Y;
                lab.Text = "Pinch Started";
            }
            if (e.Status == GestureStatus.Running)
            {
                // Calculate the scale factor to be applied.
                currentScale += (e.Scale - 1); //* startScale;
                currentScale = Math.Max(0.5, currentScale);
                currentScale = Math.Min(4, currentScale);
                // Apply scale factor.
                image.Scale = currentScale;
            }
            if (e.Status == GestureStatus.Completed)
            {
                lab.Text = "Pinch Completed";

            }
            info.Text = "Pinched mit " + currentScale.ToString("f3")+" originx "+ e.ScaleOrigin.X.ToString("f2")+ " originy " + e.ScaleOrigin.Y.ToString("f2");

        }

        double xoff = 0, yoff = 0;
 
        private void Pan_PanUpdated(object sender, PanUpdatedEventArgs e)
        {
            lab.Text = "Image is panned "+ image.TranslationX.ToString("f2")+" "+ image.TranslationY.ToString("f2");
            double x=e.TotalX, y=e.TotalY;
            if (e.StatusType==GestureStatus.Running)
            {
                info.Text = "Pan Running x=" + x.ToString("f2") + "  y= " + y.ToString("f2");
                image.TranslationX = x*image.Scale+xoff;
                image.TranslationY = y*image.Scale+yoff;
                if (Device.RuntimePlatform == Device.Android)
                {
                    xoff = image.TranslationX;
                    yoff = image.TranslationY;
                }
                info.Text = "imagescale= " + image.Scale.ToString("f2");
            }
            if (e.StatusType==GestureStatus.Completed)
            {
                lab.Text = "Pan Completed";
            }
            if (e.StatusType==GestureStatus.Started)
            {
                lab.Text = "Pan Started";
                xoff = image.TranslationX;
                yoff = image.TranslationY;

            }
        }

        private void Tap_Tapped(object sender, EventArgs e)
        {
            info.Text = "Image is tapped on ";
            xoff = image.TranslationX;
            yoff = image.TranslationY;
        }


        private void Image_SizeChanged(object sender, EventArgs e)
        {
            //lab.Text = "Width= " + image.Width + "Height= " + image.Height;
        }

 
    }
}