﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

using Xamarin.Forms;

namespace AppBayFinal2019
{
    public class PageTab2 : ContentPage
    {
        Page1 MeinMain;
        Image butback;
        Label lab;
        Image image;
        Picker pic1;
        Picker picVO;
        Picker picHO;

        public PageTab2(Page1 m)
        {
            //this.Title = "Image sizing with scroll only vertical";

            MeinMain = m;
            butback = new Image
            {
                WidthRequest = 30,
                HorizontalOptions = LayoutOptions.Start,
                BackgroundColor = MeinMain.ColorBack,
                Source = ImageSource.FromResource(MeinMain.BackIcon)
            };

            TapGestureRecognizer tap = new TapGestureRecognizer();
            tap.Tapped += Tap_Tapped;
            butback.GestureRecognizers.Add(tap);

            Label LabTitle = new Label
            {
                Text = "Image sizing with scroll only vertical",
                FontSize = 20.0,
                HorizontalOptions = LayoutOptions.End,
                BackgroundColor = MeinMain.ColorBack,
                TextColor = MeinMain.ColorText
            };
            StackLayout top = new StackLayout
            {
                Orientation = StackOrientation.Horizontal,
                Children =
                {
                   butback,LabTitle
                },
                HorizontalOptions = LayoutOptions.FillAndExpand,
                BackgroundColor = MeinMain.ColorBack,
                Padding = new Thickness(10, 0, 0, 0)
            };

            lab = new Label
            {
                Text = "Dies ist Seite Tab2",
                VerticalOptions = LayoutOptions.Start
            };
       

            Slider sl = new Slider
            {
                Maximum = 1000,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start
            };
            sl.ValueChanged += Sl_ValueChanged;
            Slider sl2 = new Slider
            {
                Maximum = 1000,
                HorizontalOptions = LayoutOptions.Fill,
                VerticalOptions = LayoutOptions.Start
            };
            sl2.ValueChanged += Sl2_ValueChanged;

            pic1 = new Picker
            {
                VerticalOptions = LayoutOptions.Start,
                
            };
            pic1.Items.Add("AspektFit");
            pic1.Items.Add("AspektFill");
            pic1.Items.Add("Fill");
            
            pic1.SelectedIndexChanged += Pic1_SelectedIndexChanged;

            picVO = new Picker
            {
                VerticalOptions = LayoutOptions.Start,
            };
            picVO.Items.Add("Vert Fill");
            picVO.Items.Add("Vert Start");
            picVO.Items.Add("Vert End");
            picVO.Items.Add("Vert Center");
            picVO.Items.Add("Vert Fill+Exp");
            picVO.Items.Add("Vert Start+Exp");
            picVO.Items.Add("Vert End+Exp");
            picVO.Items.Add("Vert Cent+Exp");
            picVO.SelectedIndexChanged += PicVO_SelectedIndexChanged;
            


            picHO = new Picker
            {
                VerticalOptions = LayoutOptions.Start,
            };

            picHO.Items.Add("Hor Fill");
            picHO.Items.Add("Hor Start");
            picHO.Items.Add("Hor End");
            picHO.Items.Add("Hor Center");
            picHO.Items.Add("Hor Fill+Exp");
            picHO.Items.Add("Hor Start+Exp");
            picHO.Items.Add("Hor End+Exp");
            picHO.Items.Add("Hor Cent+Exp");
            
            picHO.SelectedIndexChanged += PicHO_SelectedIndexChanged;


            image = new Image
            {
                Source = ImageSource.FromResource(MeinMain.PicResource),
                //Source = ImageSource.FromUri(new Uri("http://www.joergbayerlein.de/wp-content/uploads/2015/06/regcSharp.jpg")),
                //VerticalOptions = LayoutOptions.Fill,
                //Aspect = Aspect.AspectFit,
                //HorizontalOptions = LayoutOptions.Fill,
                BackgroundColor = Color.Gray,
                
            };
            image.SizeChanged += Image_SizeChanged;

            StackLayout stloPic = new StackLayout
            {
                Orientation = StackOrientation.Horizontal,
                Children={ pic1,picHO,picVO}
            
            };
            picHO.SelectedIndex = 0;
            picVO.SelectedIndex = 0;
            pic1.SelectedIndex = 0;
            Content = new StackLayout
            {
                
                Children =
                {
                    top,lab,sl,sl2,
                    stloPic,
                    new ScrollView
                    {
                        Content= image
                    }
                }
            };
            if (Device.RuntimePlatform == Device.UWP)
                this.butback.IsVisible = false;
            else if (Device.RuntimePlatform == Device.iOS)
                this.butback.Source = ImageSource.FromResource(MeinMain.BackIconiOS);
        }

        private void Tap_Tapped(object sender, EventArgs e)
        {
            MeinMain.IsPresented = true;
        }

        private void PicHO_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (picHO.SelectedIndex)
            {
                case 0: image.HorizontalOptions = LayoutOptions.Fill; break;
                case 1: image.HorizontalOptions = LayoutOptions.Start; break;
                case 2: image.HorizontalOptions = LayoutOptions.End; break;
                case 3: image.HorizontalOptions = LayoutOptions.Center; break;
                case 4: image.HorizontalOptions = LayoutOptions.FillAndExpand; break;
                case 5: image.HorizontalOptions = LayoutOptions.StartAndExpand; break;
                case 6: image.HorizontalOptions = LayoutOptions.EndAndExpand; break;
                case 7: image.HorizontalOptions = LayoutOptions.CenterAndExpand; break;

            }
        }

            private void PicVO_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (picVO.SelectedIndex)
            {
                case 0: image.VerticalOptions = LayoutOptions.Fill; break;
                case 1: image.VerticalOptions = LayoutOptions.Start; break;
                case 2: image.VerticalOptions = LayoutOptions.End; break;
                case 3: image.VerticalOptions = LayoutOptions.Center; break;
                case 4: image.VerticalOptions = LayoutOptions.FillAndExpand; break;
                case 5: image.VerticalOptions = LayoutOptions.StartAndExpand; break;
                case 6: image.VerticalOptions = LayoutOptions.EndAndExpand; break;
                case 7: image.VerticalOptions = LayoutOptions.CenterAndExpand; break;
            }
        }

        private void Pic1_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (pic1.SelectedIndex)
            {
                case 0: image.Aspect = Aspect.AspectFit; break;
                case 1: image.Aspect = Aspect.AspectFill; break;
                case 2: image.Aspect = Aspect.Fill; break;
            }
        }

        private void Image_SizeChanged(object sender, EventArgs e)
        {
            lab.Text = "Width= " + image.Width + "Height= " + image.Height;
        }

        private void Sl2_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            image.HeightRequest = e.NewValue;
            lab.Text = "Height= " + image.Height;
        }

        private void Sl_ValueChanged(object sender, ValueChangedEventArgs e)
        {
            image.WidthRequest = e.NewValue;
            lab.Text = "Width= " + image.Width;

        }
    }
}